<template>
  <v-container>
    <v-card class="mx-auto fill-height" align="center" justify="center">
      <v-card-title>
        <v-img
          height="300px"
          :src="`https://picsum.photos/500/300?image=${
            Math.floor(Math.random() * (550 - 560 + 1)) + 560
          }`"
        >
          <v-row align="center" class="mt-1" justify="center">
            <v-avatar class="profile" color="grey" size="295">
              <v-img :src="form.imageUrl"></v-img>
            </v-avatar>
            <v-btn outlined small fab color="indigo" @click="windowsVal = 2">
              <v-icon> mdi-account-cog </v-icon>
            </v-btn>
          </v-row>
        </v-img>
      </v-card-title>

      <v-card-text>
        <div>
          <v-window v-model="windowsVal">
            <v-window-item :value="1" v-if="no">
              <v-alert outlined color="indigo">
                <div class="title">{{ this.form.name }}</div>
                <div class="title">{{ this.form.email }}</div>
                <div class="title">{{ this.form.birthday }}</div>
              </v-alert>
            </v-window-item>
            <v-window-item :value="2">
              <template>
                <v-row class="mt-5">
                  <v-col cols="12">
                    <v-text-field
                      v-model="form.name"
                      :error-messages="nameErrors"
                      label="ชื่อ-สกุล"
                      required
                      @input="$v.form.name.$touch()"
                      @blur="$v.form.name.$touch()"
                      outlined
                      prepend-icon="mdi-account-box"
                    ></v-text-field
                  ></v-col>
                  <v-col cols="12"
                    ><v-text-field
                      v-model="form.email"
                      label="email"
                      outlined
                      disabled
                      prepend-icon="mdi-email-edit"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-menu
                      v-model="menu2"
                      :close-on-content-click="false"
                      :nudge-right="40"
                      transition="scale-transition"
                      offset-y
                      min-width="290px"
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-text-field
                          v-model="form.birthday"
                          label="วันเกิด"
                          prepend-icon="mdi-calendar"
                          readonly
                          v-bind="attrs"
                          v-on="on"
                          outlined
                          :error-messages="birthdayErrors"
                          @input="$v.form.birthday.$touch()"
                          @blur="$v.form.birthday.$touch()"
                        ></v-text-field>
                      </template>
                      <v-date-picker
                        v-model="form.birthday"
                        @input="menu2 = false"
                      ></v-date-picker>
                    </v-menu>
                  </v-col>
                  <v-col cols="12">
                    <v-file-input
                      outlined
                      show-size
                      label="เลือกไฟล์"
                      v-model="form.imageFile"
                      filled
                      accept="image/png, image/jpeg, image/bmp"
                      prepend-icon="mdi-camera"
                    >
                    </v-file-input
                  ></v-col>
                  <v-col cols="12">
                    <v-btn color="success" v-if="no" @click="windowsVal--">
                      กลับหน้าแรก
                    </v-btn>
                    <v-btn
                      class="ml-4"
                      color="primary"
                      v-if="ok"
                      @click="saveData"
                    >
                      บันทึก
                    </v-btn>
                    <v-btn
                      class="ml-4"
                      color="warning"
                      v-if="no"
                      @click="saveData"
                    >
                      แก้ไข
                    </v-btn>
                  </v-col>
                </v-row>
              </template>
            </v-window-item>
          </v-window>
        </div>
      </v-card-text>
    </v-card>
  </v-container>
</template>
<script>
import { mapGetters, mapActions, mapState } from 'vuex'
import { storage } from '@/services/firebase'
import { validationMixin } from 'vuelidate'
import { required } from 'vuelidate/lib/validators'
import Swal from 'sweetalert2'

export default {
  mixins: [validationMixin],
  validations: {
    form: {
      name: { required },
      birthday: { required },
    },
    value: 1,
  },
  created() {
    this.form.email = this.getUser.email
  },
  data: () => ({
    form: {
      name: null,
      email: '',
      birthday: null,
      imageUrl:
        'https://avataaars.io/?avatarStyle=Circle&topType=LongHairFrida&accessoriesType=Kurt&hairColor=Red&facialHairType=BeardLight&facialHairColor=BrownDark&clotheType=GraphicShirt&clotheColor=Gray01&graphicType=Skull&eyeType=Wink&eyebrowType=RaisedExcitedNatural&mouthType=Disbelief&skinColor=Brown',
    },
    getImageFile: '',
    ok: true,
    no: false,
    defaultItem: {
      name: null,
      email: '',
      birthday: null,
      imageUrl: null,
    },
    windowsVal: 1,
    menu2: false,
  }),
  methods: {
    getImage() {
      const min = 550
      const max = 560
      return Math.floor(Math.random() * (max - min + 1)) + min
    },
  },
  watch: {},
  computed: {
    ...mapGetters({
      getProfile: 'getProfile',
      getUser: 'getUser',
    }),
    ...mapState({
      getStateProfile: (state) => state.profile.profile,
    }),
    nameErrors() {
      const errors = []
      if (!this.$v.form.name.$dirty) return errors
      !this.$v.form.name.required && errors.push('Name is required.')
      return errors
    },
    birthdayErrors() {
      const errors = []
      if (!this.$v.form.birthday.$dirty) return errors
      !this.$v.form.birthday.required && errors.push('Name is required.')
      return errors
    },
  },
  watch: {
    getStateProfile() {
      if (this.$nuxt.$store.state.profile.profile.name === null) {
        this.ok = false
        this.no = true
        this.windowsVal = 2
        console.log('NO')
      } else {
        this.windowsVal = 1
        this.ok = false
        this.no = true
        this.form = this.$nuxt.$store.state.profile.profile
        console.log('Yes')
      }
    },
  },
  mounted() {
    this.callProfile()
  },
  methods: {
    ...mapActions({
      callProfile: 'callProfile',
    }),
    async saveData() {
      this.$v.$touch()
      if (this.$v.$invalid) {
        console.log('Error')
      } else {
        let getURL = ''
        if (this.form.imageFile != null) {
          const urlImage = await this.saveImageProfile(
            this.getUser,
            this.form.imageFile
          )

          getURL = await urlImage.ref.getDownloadURL().then((url) => {
            return url
          })
        }
        this.$store
          .dispatch('addProfile', {
            formVal: this.form,
            urlVal: getURL,
          })
          .then(() => {
            this.form = Object.assign({}, this.defaultItem)
            const Toast = Swal.mixin({
              toast: true,
              position: 'top',
              showConfirmButton: false,
              timer: 2000,
              timerProgressBar: true,
              didOpen: (toast) => {
                toast.addEventListener('mouseenter', Swal.stopTimer)
                toast.addEventListener('mouseleave', Swal.resumeTimer)
              },
            })

            Toast.fire({
              icon: 'success',
              title: 'บันทึกข้อมูลสำเร็จ',
            })
            this.$store.commit('SET_FORM_EXPENSES_TYPE', false)
          })
          .catch((error) => {
            setTimeout(() => {
              console.log('Error :', error.code)
            }, 2000)
          })
      }
    },
    async saveImageProfile(user, image) {
      const userID = user.uid
      const listRef = await storage
        .child(`mainBucket/profile/${userID}/${image.name}`)
        .put(image)
        .then((response) => {
          return response
        })
      return listRef
    },
  },
}
</script>
